	package proj2;


	public class BoardModel extends Object {
	   
	   private int noOfRows, noOfCols, currentPlayer, lastRow,
		            noOfChips;
		private int[][] board;

		public BoardModel(int ro, int co){
		   //test for ro,co >= 3;

			noOfRows = ro;
			noOfCols = co;
		

			board	   = new int[noOfRows][noOfCols];
			reset();
		}// constructor


		public void setChipAt(int ro, int co){
		 if( checkOK(ro,co) && !gameOver() ){

	    	 board[ro][co]  =  currentPlayer;
			 lastRow = ro;
			 changePlayer();
			 noOfChips++;
		  }

		}//method 

		private boolean  checkOK(int ro, int co){
			return(
				(0 <= ro) && (ro < noOfRows) &&
			 	(0 <= co) && (co < noOfCols) &&
				(board[ro][co] == Const.EMPTY)
			);
		}

		private void changePlayer(){
			if(currentPlayer == Const.RED){
				currentPlayer = Const.BLACK;
			}
			else{
			  currentPlayer  = Const.RED;
			}

		}

		public void reset(){
			for(int r = 0; r < noOfRows; r++){
			   for(int c = 0; c < noOfCols; c++){
					board[r][c] = Const.EMPTY;	
				}//for c
			}//for r

			currentPlayer = Const.RED;
			noOfChips = 0;
		}

		public int getChipAt(int ro, int co){
			 // test for 0 <= ro < noOfRows and
 			 //          0 <= ro < noOfCols 
			 return(board[ro][co]);
			
		}

		public boolean gameOver(){

		   
		   boolean over = false;
			for(int c = 0; c < noOfCols - 2; c++){
			  if(
			     (
				  (board[lastRow][c]     == board[lastRow][c+1]) && 
			   	(board[lastRow][c+1]  == board[lastRow][c+2])
					&&((board[lastRow][c] == Const.RED) ||					
					    (board[lastRow][c] == Const.BLACK))
					) || (noOfChips == noOfRows*noOfCols)
					
					){
 				  over = true;
				}
			}//for i

			return(over);
		}

		public void print(){
			for(int r = 0; r < noOfRows; r++){
			   for(int c = 0; c < noOfCols; c++){
					 System.out.print(" "+board[r][c]);
				}//for c
				System.out.println();
		}//for r
		System.out.println();
		}

	  public int getNoOfRows(){
	  return(noOfRows);
	  }
	  public int getNoOfCols(){
	  return(noOfCols);
	  }

	}//class 
