package proj2;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class BoardPanel extends JPanel {

		private BoardModel model;
		private int noOfRows, noOfCols;

		public BoardPanel(BoardModel bm){
			 model = bm;

	/*		 bm.setChipAt(1,1);
			 bm.setChipAt(3,1);
			 bm.setChipAt(0,1);
			 bm.setChipAt(1,0);  */

			 BoardListener blis = new  BoardListener();
			 this.addMouseListener(blis);


			 noOfRows	= model.getNoOfRows();
			 noOfCols	= model.getNoOfCols();
			 this.setBackground(Color.pink);
			 this.setPreferredSize(new Dimension(300,300));
		}

		public void paintComponent(Graphics g){
			 super.paintComponent(g);
			 int width  = this.getWidth();
			 int height = this.getHeight();
			 int colWidth   = width/noOfCols;
			 int rowHeight  = height/noOfRows;

			 g.setColor(Color.black);

			 for(int i = 1; i <= noOfCols - 1 ; i++){
			  g.drawLine( i*colWidth, 0, i*colWidth, height);
			 }//for i

			 for(int i = 1; i <= noOfRows - 1; i++){
				 g.drawLine( 0,i*rowHeight, width, i*rowHeight);
			 }//for i

			 for(int r = 0; r < noOfRows; r++){
			    for(int c = 0; c < noOfCols; c++){

				 if(model.getChipAt(r,c) == Const.RED){
				   g.setColor(Color.red);
					g.fillOval(c*colWidth,r*rowHeight,
					           colWidth,rowHeight);


				 } else if(model.getChipAt(r,c) == Const.BLACK){
					 g.setColor(Color.black);
				    g.fillOval(c*colWidth,r*rowHeight,
					           colWidth,rowHeight);

				 }

				 }//for c
			 }//for r


		}//paintComponent


		class BoardListener implements MouseListener{
       
		   public void mouseClicked(MouseEvent me){
				 System.out.println("click");

				int xClick = me.getX();
				int yClick = me.getY();
		      int width  = getWidth();
			   int height = getHeight();
			   int colWidth   = width/noOfCols;
			   int rowHeight  = height/noOfRows;	
		    
				int colClick   = xClick/colWidth;
				int rowClick   = yClick/rowHeight;

				model.setChipAt(rowClick,colClick);

				repaint();

				System.out.println("Over="+model.gameOver());

			}


			public void mousePressed(MouseEvent me){
			  // nothing
			}


		   public void mouseReleased(MouseEvent me){
			  // nothing
			}
		   public void mouseExited(MouseEvent me){
			  // nothing
			}
		   public void mouseEntered(MouseEvent me){
			  // nothing
			}

		}

	
}//class 